Adding all for bootstrap
[awesomized/libmemcached] / bootstrap.sh
1 #!/bin/bash
2 #
3 # Copyright (C) 2012-2013 Brian Aker
4 # All rights reserved.
5 #
6 # Redistribution and use in source and binary forms, with or without
7 # modification, are permitted provided that the following conditions are
8 # met:
9 #
10 # * Redistributions of source code must retain the above copyright
11 # notice, this list of conditions and the following disclaimer.
12 #
13 # * Redistributions in binary form must reproduce the above
14 # copyright notice, this list of conditions and the following disclaimer
15 # in the documentation and/or other materials provided with the
16 # distribution.
17 #
18 # * The names of its contributors may not be used to endorse or
19 # promote products derived from this software without specific prior
20 # written permission.
21 #
22 # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
23 # "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
24 # LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
25 # A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
26 # OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
27 # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
28 # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
29 # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
30 # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
31 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
32 # OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
33
34
35 # Environment Variables that will influence the build:
36 # AUTOMAKE
37 # AUTORECONF
38 # LIBTOOLIZE
39 # MAKE
40 # PREFIX
41 # TESTS_ENVIRONMENT
42 # VERBOSE
43 # WARNINGS
44 #
45
46 command_not_found_handle ()
47 {
48 warn "$@: command not found"
49
50 #if $DEBUG; then
51 echo ""
52 echo "Stack trace:"
53 local frame=0
54 while caller $frame; do
55 ((frame++));
56 done
57 echo ""
58 #fi
59
60 return 127
61 }
62
63 function error ()
64 {
65 echo "$BASH_SOURCE:$BASH_LINENO: $@" >&2
66 }
67
68 function die ()
69 {
70 echo "$BASH_SOURCE:$BASH_LINENO: $@" >&2
71 exit 1;
72 }
73
74 function warn ()
75 {
76 echo "$BASH_SOURCE:$BASH_LINENO: $@"
77 #echo "$BASH_SOURCE:$BASH_LINENO: $@" >&1
78 }
79
80 function nassert ()
81 {
82 local param_name=\$"$1"
83 local param_value=`eval "expr \"$param_name\" "`
84
85 if [ -n "$param_value" ]; then
86 echo "$bash_source:$bash_lineno: assert($param_name) had value of "$param_value"" >&2
87 exit 1
88 fi
89 }
90
91 function assert ()
92 {
93 local param_name=\$"$1"
94 local param_value=`eval "expr \"$param_name\" "`
95
96 if [ -z "$param_value" ]; then
97 echo "$bash_source:$bash_lineno: assert($param_name)" >&2
98 exit 1
99 fi
100 }
101
102 function assert_file ()
103 {
104 if [ ! -f "$1" ]; then
105 echo "$BASH_SOURCE:$BASH_LINENO: assert($1) does not exist: $2" >&2
106 exit 1;
107 fi
108 }
109
110 function assert_no_file ()
111 {
112 if [ -f "$1" ]; then
113 echo "$BASH_SOURCE:$BASH_LINENO: assert($1) file exists: $2" >&2
114 exit 1;
115 fi
116 }
117
118 function assert_no_directory ()
119 {
120 if [ -d "$1" ]; then
121 echo "$BASH_SOURCE:$BASH_LINENO: assert($1) directory exists: $2" >&2
122 exit 1;
123 fi
124 }
125
126 function assert_exec_file ()
127 {
128 if [ ! -f "$1" ]; then
129 echo "$BASH_SOURCE:$BASH_LINENO: assert($1) does not exist: $2" >&2
130 exit 1;
131 fi
132
133 if [ ! -x "$1" ]; then
134 echo "$BASH_SOURCE:$BASH_LINENO: assert($1) exists but is not executable: $2" >&2
135 exit 1;
136 fi
137 }
138
139 function command_exists ()
140 {
141 type "$1" &> /dev/null ;
142 }
143
144 function rebuild_host_os ()
145 {
146 HOST_OS="${UNAME_MACHINE_ARCH}-${VENDOR}-${VENDOR_DISTRIBUTION}-${VENDOR_RELEASE}-${UNAME_KERNEL}-${UNAME_KERNEL_RELEASE}"
147 if [ -z "$1" ]; then
148 if $VERBOSE; then
149 echo "HOST_OS=$HOST_OS"
150 fi
151 fi
152 }
153
154 # Validate the distribution name, or toss an erro
155 # values: darwin,fedora,rhel,ubuntu,debian,opensuse
156 function set_VENDOR_DISTRIBUTION ()
157 {
158 local dist=`echo "$1" | tr '[A-Z]' '[a-z]'`
159 case "$dist" in
160 darwin)
161 VENDOR_DISTRIBUTION='darwin'
162 ;;
163 fedora)
164 VENDOR_DISTRIBUTION='fedora'
165 ;;
166 rhel)
167 VENDOR_DISTRIBUTION='rhel'
168 ;;
169 debian)
170 VENDOR_DISTRIBUTION='debian'
171 ;;
172 ubuntu)
173 VENDOR_DISTRIBUTION='ubuntu'
174 ;;
175 suse)
176 VENDOR_DISTRIBUTION='opensuse'
177 ;;
178 opensuse)
179 VENDOR_DISTRIBUTION='opensuse'
180 ;;
181 *)
182 die "attempt to set an invalid VENDOR_DISTRIBUTION=$dist"
183 ;;
184 esac
185 }
186
187 # Validate a Vendor's release name/number
188 function set_VENDOR_RELEASE ()
189 {
190 local release=`echo "$1" | tr '[A-Z]' '[a-z]'`
191
192 if $DEBUG; then
193 echo "VENDOR_DISTRIBUTION:$VENDOR_DISTRIBUTION"
194 echo "VENDOR_RELEASE:$release"
195 fi
196
197 case $VENDOR_DISTRIBUTION in
198 darwin)
199 case $release in
200 10.6*)
201 VENDOR_RELEASE='snow_leopard'
202 ;;
203 10.7*)
204 VENDOR_RELEASE='mountain'
205 ;;
206 mountain)
207 VENDOR_RELEASE='mountain'
208 ;;
209 10.8.*)
210 echo "mountain_lion"
211 VENDOR_RELEASE='mountain_lion'
212 ;;
213 *)
214 echo $VENDOR_RELEASE
215 VENDOR_RELEASE='unknown'
216 ;;
217 esac
218 ;;
219 fedora)
220 VENDOR_RELEASE="$release"
221 if [[ "x$VENDOR_RELEASE" == '18' ]]; then
222 VENDOR_RELEASE='sphericalcow'
223 fi
224 ;;
225 rhel)
226 VENDOR_RELEASE="$release"
227 ;;
228 debian)
229 VENDOR_RELEASE="$release"
230 ;;
231 ubuntu)
232 VENDOR_RELEASE="$release"
233 if [[ "x$VENDOR_RELEASE" == 'x12.04' ]]; then
234 VENDOR_RELEASE="precise"
235 elif [[ "x$VENDOR_RELEASE" == 'x12.10' ]]; then
236 VENDOR_RELEASE="quantal"
237 elif [[ "x$VENDOR_RELEASE" == 'x13.04' ]]; then
238 VENDOR_RELEASE="raring"
239 fi
240 ;;
241 opensuse)
242 VENDOR_RELEASE="$release"
243 ;;
244 unknown)
245 die "attempt to set VENDOR_RELEASE without setting VENDOR_DISTRIBUTION"
246 ;;
247 *)
248 die "attempt to set with an invalid VENDOR_DISTRIBUTION=$VENDOR_DISTRIBUTION"
249 ;;
250 esac
251 }
252
253
254 # Valid values are: apple, redhat, centos, canonical, oracle, suse
255 function set_VENDOR ()
256 {
257 local vendor=`echo "$1" | tr '[A-Z]' '[a-z]'`
258
259 case $vendor in
260 apple)
261 VENDOR='apple'
262 ;;
263 redhat)
264 VENDOR='redhat'
265 ;;
266 fedora)
267 VENDOR='redhat'
268 ;;
269 redhat-release-server-*)
270 VENDOR='redhat'
271 ;;
272 enterprise-release-*)
273 VENDOR='oracle'
274 ;;
275 centos)
276 VENDOR='centos'
277 ;;
278 canonical)
279 VENDOR='canonical'
280 ;;
281 ubuntu)
282 VENDOR='canonical'
283 ;;
284 debian)
285 VENDOR='debian'
286 ;;
287 opensuse)
288 VENDOR='suse'
289 ;;
290 suse)
291 VENDOR='suse'
292 ;;
293 *)
294 die "An attempt was made to set an invalid VENDOR=$_vendor"
295 ;;
296 esac
297
298 set_VENDOR_DISTRIBUTION $2
299 set_VENDOR_RELEASE $3
300
301 # Set which vendor/versions we trust for autoreconf
302 case $VENDOR_DISTRIBUTION in
303 fedora)
304 if [[ "x$VENDOR_RELEASE" == 'x18' ]]; then
305 AUTORECONF_REBUILD_HOST=true
306 elif [[ "x$VENDOR_RELEASE" == 'xsphericalcow' ]]; then
307 AUTORECONF_REBUILD_HOST=true
308 elif [[ "x$VENDOR_RELEASE" == 'x19' ]]; then
309 AUTORECONF_REBUILD_HOST=true
310 fi
311 ;;
312 canonical)
313 if [[ "x$VENDOR_RELEASE" == 'xprecise' ]]; then
314 AUTORECONF_REBUILD_HOST=true
315 elif [[ "x$VENDOR_RELEASE" == 'xquantal' ]]; then
316 AUTORECONF_REBUILD_HOST=true
317 fi
318 ;;
319 esac
320
321 }
322
323 function determine_target_platform ()
324 {
325 UNAME_MACHINE_ARCH=`(uname -m) 2>/dev/null` || UNAME_MACHINE_ARCH=unknown
326 UNAME_KERNEL=`(uname -s) 2>/dev/null` || UNAME_SYSTEM=unknown
327 UNAME_KERNEL_RELEASE=`(uname -r) 2>/dev/null` || UNAME_KERNEL_RELEASE=unknown
328
329 if [[ -x '/usr/bin/sw_vers' ]]; then
330 local _VERSION=`/usr/bin/sw_vers -productVersion`
331 set_VENDOR 'apple' 'darwin' $_VERSION
332 elif [[ $(uname) == 'Darwin' ]]; then
333 set_VENDOR 'apple' 'darwin' 'mountain'
334 elif [[ -f '/etc/fedora-release' ]]; then
335 local fedora_version=`cat /etc/fedora-release | awk ' { print $3 } '`
336 set_VENDOR 'redhat' 'fedora' $fedora_version
337 elif [[ -f '/etc/centos-release' ]]; then
338 local centos_version=`cat /etc/centos-release | awk ' { print $7 } '`
339 set_VENDOR 'centos' 'rhel' $centos_version
340 elif [[ -f '/etc/SuSE-release' ]]; then
341 local suse_distribution=`head -1 /etc/SuSE-release | awk ' { print $1 } '`
342 local suse_version=`head -1 /etc/SuSE-release | awk ' { print $2 } '`
343 set_VENDOR 'suse' $suse_distribution $suse_version
344 elif [[ -f '/etc/redhat-release' ]]; then
345 local rhel_version=`cat /etc/redhat-release | awk ' { print $7 } '`
346 local _vendor=`rpm -qf /etc/redhat-release`
347 set_VENDOR $_vendor 'rhel' $rhel_version
348 elif [[ -f '/etc/os-release' ]]; then
349 source '/etc/os-release'
350 set_VENDOR $ID $ID $VERSION_ID
351 elif [[ -x '/usr/bin/lsb_release' ]]; then
352 local _ID=`/usr/bin/lsb_release -s -i`
353 local _VERSION=`/usr/bin/lsb_release -s -r`
354 set_VENDOR $_ID $_ID $_VERSION_ID
355 elif [[ -f '/etc/lsb-release' ]]; then
356 source '/etc/lsb-release'
357 set_VENDOR 'canonical' $DISTRIB_ID $DISTRIB_CODENAME
358 fi
359
360 rebuild_host_os
361 }
362
363 function run_configure ()
364 {
365 # We will run autoreconf if we are required
366 run_autoreconf_if_required
367
368 # We always begin at the root of our build
369 if [ ! popd ]; then
370 die "Programmer error, we entered run_configure with a stacked directory"
371 fi
372
373 if ! command_exists "$CONFIGURE"; then
374 die "$CONFIGURE does not exist"
375 fi
376
377 local BUILD_DIR="$1"
378 if [[ -n "$BUILD_DIR" ]]; then
379 rm -r -f $BUILD_DIR
380 mkdir -p $BUILD_DIR
381 safe_pushd $BUILD_DIR
382 fi
383
384 # Arguments for configure
385 local BUILD_CONFIGURE_ARG=
386
387 # If ENV DEBUG is set we enable both debug and asssert, otherwise we see if this is a VCS checkout and if so enable assert
388 # Set ENV ASSERT in order to enable assert.
389 # If we are doing a valgrind run, we always compile with assert disabled
390 if $valgrind_run; then
391 BUILD_CONFIGURE_ARG+= " CXXFLAGS=-DNDEBUG "
392 BUILD_CONFIGURE_ARG+= " CFLAGS=-DNDEBUG "
393 else
394 if $DEBUG; then
395 BUILD_CONFIGURE_ARG+=' --enable-debug --enable-assert'
396 elif [[ -n "$VCS_CHECKOUT" ]]; then
397 BUILD_CONFIGURE_ARG+=' --enable-assert'
398 fi
399 fi
400
401 if [[ -n "$CONFIGURE_ARG" ]]; then
402 BUILD_CONFIGURE_ARG+=" $CONFIGURE_ARG"
403 fi
404
405 if [[ -n "$PREFIX_ARG" ]]; then
406 BUILD_CONFIGURE_ARG+=" $PREFIX_ARG"
407 fi
408
409 ret=1;
410 # If we are executing on OSX use CLANG, otherwise only use it if we find it in the ENV
411 case $HOST_OS in
412 *-darwin-*)
413 CC=clang CXX=clang++ $top_srcdir/configure $BUILD_CONFIGURE_ARG || die "Cannot execute CC=clang CXX=clang++ configure $BUILD_CONFIGURE_ARG"
414 ret=$?
415 ;;
416 rhel-5*)
417 command_exists 'gcc44' || die "Could not locate gcc44"
418 CC=gcc44 CXX=gcc44 $top_srcdir/configure $BUILD_CONFIGURE_ARG || die "Cannot execute CC=gcc44 CXX=gcc44 configure $BUILD_CONFIGURE_ARG"
419 ret=$?
420 ;;
421 *)
422 $CONFIGURE $BUILD_CONFIGURE_ARG
423 ret=$?
424 ;;
425 esac
426
427 if [ $ret -ne 0 ]; then
428 die "Could not execute $CONFIGURE $BUILD_CONFIGURE_ARG"
429 fi
430
431 if [ ! -f 'Makefile' ]; then
432 die "Programmer error, configure was run but no Makefile existed after $CONFIGURE was run"
433 fi
434 }
435
436 function setup_gdb_command () {
437 GDB_TMPFILE=$(mktemp /tmp/gdb.XXXXXXXXXX)
438 echo 'set logging overwrite on' > $GDB_TMPFILE
439 echo 'set logging on' >> $GDB_TMPFILE
440 echo 'set environment LIBTEST_IN_GDB=1' >> $GDB_TMPFILE
441 echo 'run' >> $GDB_TMPFILE
442 echo 'thread apply all bt' >> $GDB_TMPFILE
443 echo 'quit' >> $GDB_TMPFILE
444 GDB_COMMAND="gdb -f -batch -x $GDB_TMPFILE"
445 }
446
447 function setup_valgrind_command () {
448 VALGRIND_PROGRAM=`type -p valgrind`
449 if [[ -n "$VALGRIND_PROGRAM" ]]; then
450 VALGRIND_COMMAND="$VALGRIND_PROGRAM --error-exitcode=1 --leak-check=yes --malloc-fill=A5 --free-fill=DE --xml=yes --xml-file=\"valgrind-%p.xml\""
451 fi
452 }
453
454 function save_BUILD ()
455 {
456 if [[ -n "$OLD_CONFIGURE" ]]; then
457 die "OLD_CONFIGURE($OLD_CONFIGURE) was set on push, programmer error!"
458 fi
459
460 if [[ -n "$OLD_CONFIGURE_ARG" ]]; then
461 die "OLD_CONFIGURE_ARG($OLD_CONFIGURE_ARG) was set on push, programmer error!"
462 fi
463
464 if [[ -n "$OLD_PREFIX" ]]; then
465 die "OLD_PREFIX($OLD_PREFIX) was set on push, programmer error!"
466 fi
467
468 if [[ -n "$OLD_MAKE" ]]; then
469 die "OLD_MAKE($OLD_MAKE) was set on push, programmer error!"
470 fi
471
472 if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
473 die "OLD_TESTS_ENVIRONMENT($OLD_TESTS_ENVIRONMENT) was set on push, programmer error!"
474 fi
475
476 if [[ -n "$CONFIGURE" ]]; then
477 OLD_CONFIGURE=$CONFIGURE
478 fi
479
480 if [[ -n "$CONFIGURE_ARG" ]]; then
481 OLD_CONFIGURE_ARG=$CONFIGURE_ARG
482 fi
483
484 if [[ -n "$MAKE" ]]; then
485 OLD_MAKE=$MAKE
486 fi
487
488 if [[ -n "$TESTS_ENVIRONMENT" ]]; then
489 OLD_TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT
490 fi
491 }
492
493 function restore_BUILD ()
494 {
495 if [[ -n "$OLD_CONFIGURE" ]]; then
496 CONFIGURE=$OLD_CONFIGURE
497 fi
498
499 if [[ -n "$OLD_CONFIGURE_ARG" ]]; then
500 CONFIGURE_ARG=$OLD_CONFIGURE_ARG
501 fi
502
503 if [[ -n "$OLD_PREFIX" ]]; then
504 PREFIX_ARG=$OLD_PREFIX
505 fi
506
507 if [[ -n "$OLD_MAKE" ]]; then
508 MAKE=$OLD_MAKE
509 fi
510
511 if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
512 TESTS_ENVIRONMENT=$OLD_TESTS_ENVIRONMENT
513 fi
514
515 OLD_CONFIGURE=
516 OLD_CONFIGURE_ARG=
517 OLD_PREFIX=
518 OLD_MAKE=
519 OLD_TESTS_ENVIRONMENT=
520
521 export -n CC CXX
522 }
523
524 function safe_pushd ()
525 {
526 pushd $1 &> /dev/null ;
527
528 if [ -n "$BUILD_DIR" ]; then
529 if $VERBOSE; then
530 echo "BUILD_DIR=$BUILD_DIR"
531 fi
532 fi
533 }
534
535 function safe_popd ()
536 {
537 local directory_to_delete=`pwd`
538 popd &> /dev/null ;
539 if [ $? -eq 0 ]; then
540 if [[ "$top_srcdir" == "$directory_to_delete" ]]; then
541 die "We almost deleted top_srcdir($top_srcdir), programmer error"
542 fi
543
544 rm -r -f "$directory_to_delete"
545 fi
546 }
547
548 function make_valgrind ()
549 {
550 # If the env VALGRIND_COMMAND is set then we assume it is valid
551 local valgrind_was_set=false
552 if [[ -z "$VALGRIND_COMMAND" ]]; then
553 setup_valgrind_command
554 if [[ -n "$VALGRIND_COMMAND" ]]; then
555 valgrind_was_set=true
556 fi
557 else
558 valgrind_was_set=true
559 fi
560
561 # If valgrind_was_set is set to no we bail
562 if ! $valgrind_was_set; then
563 echo 'valgrind was not present'
564 return 1
565 fi
566
567 save_BUILD
568
569 valgrind_run=true
570
571 # If we are required to run configure, do so now
572 run_configure
573
574 # If we don't have a configure, then most likely we will be missing libtool
575 assert_file 'configure'
576 if [[ -f 'libtool' ]]; then
577 TESTS_ENVIRONMENT="./libtool --mode=execute $VALGRIND_COMMAND"
578 else
579 TESTS_ENVIRONMENT="$VALGRIND_COMMAND"
580 fi
581
582 make_target 'all'
583 make_target 'check'
584 ret=$?
585
586 # If we aren't going to error, we will clean up our environment
587 if [ "$ret" -eq 0 ]; then
588 make 'distclean'
589 fi
590
591 valgrind_run=false
592
593 restore_BUILD
594
595 if [ "$ret" -ne 0 ]; then
596 return 1
597 fi
598 }
599
600 function make_install_system ()
601 {
602 local INSTALL_LOCATION=$(mktemp -d /tmp/XXXXXXXXXX)
603
604 save_BUILD
605 PREFIX_ARG="--prefix=$INSTALL_LOCATION"
606
607 if [ ! -d $INSTALL_LOCATION ] ; then
608 die "ASSERT temp directory not found '$INSTALL_LOCATION'"
609 fi
610
611 run_configure #install_buid_dir
612
613 make_target 'install'
614
615 make_target 'installcheck'
616
617 make_target 'uninstall'
618
619 rm -r -f $INSTALL_LOCATION
620 make 'distclean'
621
622 if [ -f 'Makefile' ]; then
623 die "ASSERT Makefile should not exist"
624 fi
625
626 restore_BUILD
627 safe_popd
628 }
629
630 function make_darwin_malloc ()
631 {
632 run_configure_if_required
633
634 old_MallocGuardEdges=$MallocGuardEdges
635 MallocGuardEdges=1
636 old_MallocErrorAbort=$MallocErrorAbort
637 MallocErrorAbort=1
638 old_MallocScribble=$MallocScribble
639 MallocScribble=1
640
641 make_check
642
643 MallocGuardEdges=$old_MallocGuardEdges
644 MallocErrorAbort=$old_MallocErrorAbort
645 MallocScribble=$old_MallocScribble
646 }
647
648 # This will reset our environment, and make sure built files are available.
649 function make_for_snapshot ()
650 {
651 # Lets make sure we have a clean environment
652 assert_no_file 'Makefile'
653 assert_no_file 'configure'
654 assert_no_directory 'autom4te.cache'
655
656 run_configure
657 make_target 'dist'
658 make_target 'distclean'
659
660 # We should have a configure, but no Makefile at the end of this exercise
661 assert_no_file 'Makefile'
662 assert_exec_file 'configure'
663 }
664
665 function check_mingw ()
666 {
667 command_exists 'mingw64-configure'
668 ret=$?
669 if [ "$ret" -ne 0 ]; then
670 return 1
671 fi
672
673 command_exists 'mingw64-make'
674 ret=$?
675 if [ "$ret" -ne 0 ]; then
676 return 1
677 fi
678
679 return 0
680 }
681
682 function check_clang ()
683 {
684 command_exists 'clang'
685 ret=$?
686 if [ "$ret" -ne 0 ]; then
687 return 1
688 fi
689
690 return 0
691 }
692
693 function check_clang_analyzer ()
694 {
695 command_exists 'scan-build'
696 ret=$?
697 if [ "$ret" -ne 0 ]; then
698 return 1
699 fi
700
701 return 0
702 }
703
704 function make_skeleton ()
705 {
706 run_configure
707 ret=$?
708
709 if [ $ret -eq 0 ]; then
710 assert_file 'Makefile'
711
712 make_target 'all' 'warn'
713 ret=$?
714 if [ $ret -ne 0 ]; then
715 warn "$MAKE failed"
716 else
717 if [[ -n "$DISPLAY" ]]; then
718 if command_exists 'wine'; then
719 TESTS_ENVIRONMENT='wine'
720 fi
721 fi
722
723 if [[ -n "$TESTS_ENVIRONMENT" ]]; then
724 make_target 'check' 'warn' || warn "$MAKE check failed"
725 ret=$?
726 fi
727 fi
728
729 if $jenkins_build_environment; then
730 make_target 'clean' 'warn'
731 fi
732 fi
733
734 return $ret
735 }
736
737 function make_for_mingw ()
738 {
739 if ! check_mingw; then
740 return 1
741 fi
742
743 # Make sure it is clean
744 if [ -f Makefile -o -f configure ]; then
745 make_maintainer_clean
746 fi
747
748 run_autoreconf
749
750 save_BUILD
751
752 CONFIGURE='mingw64-configure'
753 MAKE='mingw64-make'
754 CONFIGURE_ARGS='--enable-static --disable-shared'
755
756 make_skeleton
757 ret=$?
758
759 restore_BUILD
760
761 return $ret
762 }
763
764 function make_for_clang ()
765 {
766 if ! check_clang; then
767 return 1
768 fi
769
770 # Make sure it is clean
771 if [ -f Makefile -o -f configure ]; then
772 make_maintainer_clean
773 fi
774
775 run_autoreconf
776
777 save_BUILD
778
779 CC=clang CXX=clang++
780 export CC CXX
781
782 make_skeleton
783 ret=$?
784
785 make_target 'check'
786
787 restore_BUILD
788
789 return $ret
790 }
791
792 function make_for_clang_analyzer ()
793 {
794 if ! check_clang; then
795 return 1
796 fi
797
798 if ! check_clang_analyzer; then
799 die 'clang-analyzer was not found'
800 fi
801
802 # Make sure it is clean
803 if [ -f Makefile -o -f configure ]; then
804 make_maintainer_clean
805 fi
806
807 run_autoreconf
808
809 save_BUILD
810
811 CC=clang CXX=clang++
812 export CC CXX
813 CONFIGURE_ARGS='--enable-debug'
814
815 make_skeleton
816 ret=$?
817
818 make_target 'clean' 'warn'
819
820 scan-build -o clang-html make -j4 -k
821
822 restore_BUILD
823
824 return $ret
825 }
826
827 # If we are locally testing, we should make sure the environment is setup correctly
828 function check_for_jenkins ()
829 {
830 if ! $jenkins_build_environment; then
831 echo "Not inside of jenkins, simulating environment"
832
833 if [ -f 'configure' ]; then
834 make_maintainer_clean
835 fi
836
837 if $BOOTSTRAP_SNAPSHOT; then
838 make_for_snapshot
839 fi
840 fi
841 }
842
843 function make_universe ()
844 {
845 make_for_snapshot
846 make_valgrind
847 make_gdb
848 make_rpm
849 make_for_clang
850 make_for_clang_analyzer
851
852 if [ check_mingw -eq 0 ]; then
853 make_for_mingw
854 fi
855
856 make_distcheck
857 make_install_system
858 }
859
860 function make_for_continuus_integration ()
861 {
862 # Setup the environment if we are local
863 check_for_jenkins
864
865 # No matter then evironment, we should not have a Makefile at this point
866 assert_no_file 'Makefile'
867
868 # Platforms which require bootstrap should have some setup done before we hit this stage.
869 # If we are building locally, skip this step, unless we are just testing locally.
870 if $BOOTSTRAP_SNAPSHOT; then
871 if $BOOTSTRAP_SNAPSHOT; then
872 assert_file 'configure'
873 fi
874
875 if [ -n "$BOOTSTRAP_SNAPSHOT_CHECK" ]; then
876 assert_file "$BOOTSTRAP_SNAPSHOT_CHECK" 'snapshot check failed'
877 fi
878 else
879 # If we didn't require a snapshot, then we should not have a configure
880 assert_no_file 'configure'
881
882 run_autoreconf
883 fi
884
885 assert_no_file 'Makefile' 'Programmer error, Makefile existed where build state should have been clean'
886
887 case $HOST_OS in
888 *-fedora-*)
889 run_configure
890
891 assert_exec_file 'configure'
892 assert_file 'Makefile'
893
894 make_target 'all'
895
896 # make rpm includes "make distcheck"
897 if [[ -f rpm.am ]]; then
898 make_rpm
899 elif [[ -d rpm ]]; then
900 make_rpm
901 fi
902 ;;
903 *)
904 make_jenkins_default
905 ;;
906 esac
907
908 make_maintainer_clean
909
910 safe_popd
911 }
912
913 # The point to this test is to test bootstrap.sh itself
914 function self_test ()
915 {
916 # We start off with a clean env
917 make_maintainer_clean
918
919 eval "./bootstrap.sh jenkins" || die "failed 'jenkins'"
920 eval "./bootstrap.sh all" || die "failed 'all'"
921 eval "./bootstrap.sh gdb" || die "failed 'gdb'"
922 eval "./bootstrap.sh maintainer-clean" || die "failed 'maintainer-clean'"
923 }
924
925 function make_install_html ()
926 {
927 run_configure_if_required
928 assert_file 'configure'
929
930 make_target 'install-html'
931 }
932
933 function make_gdb ()
934 {
935 save_BUILD
936
937 if command_exists 'gdb'; then
938 run_configure_if_required
939
940 # Set ENV GDB_COMMAND
941 if [[ -z "$GDB_COMMAND" ]]; then
942 setup_gdb_command
943 fi
944
945 # If we don't have a configure, then most likely we will be missing libtool
946 assert_file 'configure'
947 if [[ -f 'libtool' ]]; then
948 TESTS_ENVIRONMENT="./libtool --mode=execute $GDB_COMMAND"
949 else
950 TESTS_ENVIRONMENT="$GDB_COMMAND"
951 fi
952
953 make_target 'check'
954
955 if [ -f 'gdb.txt' ]; then
956 rm 'gdb.txt'
957 fi
958
959 if [ -f '.gdb_history' ]; then
960 rm '.gdb_history'
961 fi
962
963 if $jenkins_build_environment; then
964 make_target 'clean'
965 fi
966 else
967 echo 'gdb was not present'
968 return 1
969 fi
970
971 restore_BUILD
972 }
973
974 # $1 target to compile
975 # $2 to die, or not to die, based on contents
976 function make_target ()
977 {
978 if [ -z "$1" ]; then
979 die "Programmer error, no target provided for make"
980 fi
981
982 if [ ! -f 'Makefile' ]; then
983 die "Programmer error, make was called before configure"
984 run_configure
985 fi
986
987 if [ -n "$TESTS_ENVIRONMENT" ]; then
988 if $VERBOSE; then
989 echo "TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT"
990 fi
991 fi
992
993 if [ -z "$MAKE" ]; then
994 die "MAKE was not set"
995 fi
996
997 # $2 represents error or warn
998 run $MAKE $1
999 ret=$?
1000
1001 if [ $ret -ne 0 ]; then
1002 if [ -n "$2" ]; then
1003 warn "Failed to execute $MAKE $1: $ret"
1004 else
1005 die "Failed to execute $MAKE $1: $ret"
1006 fi
1007 fi
1008
1009 return $ret
1010 }
1011
1012 function make_distcheck ()
1013 {
1014 make_target 'distcheck'
1015 }
1016
1017 function make_rpm ()
1018 {
1019 if command_exists 'rpmbuild'; then
1020 if [ -f 'rpm.am' -o -d 'rpm' ]; then
1021 run_configure_if_required
1022 make_target 'rpm'
1023
1024 if $jenkins_build_environment; then
1025 make_target 'clean'
1026 fi
1027
1028 fi
1029 fi
1030 }
1031
1032 function make_maintainer_clean ()
1033 {
1034 run_configure_if_required
1035 make_target 'maintainer-clean' 'no_error'
1036
1037 # Lets make sure we really cleaned up the environment
1038 assert_no_file 'Makefile'
1039 assert_no_file 'configure'
1040 assert_no_directory 'autom4te.cache'
1041 }
1042
1043 function make_check ()
1044 {
1045 make_target 'check'
1046 }
1047
1048 function make_jenkins_default ()
1049 {
1050 run_configure
1051 make_target 'all'
1052 }
1053
1054 function make_default ()
1055 {
1056 run_configure_if_required
1057 make_target 'all'
1058 }
1059
1060 function run_configure_if_required ()
1061 {
1062 run_autoreconf_if_required
1063
1064 if [ ! -f 'Makefile' ]; then
1065 run_configure
1066 fi
1067
1068 assert_file 'Makefile' 'configure did not produce a Makefile'
1069 }
1070
1071 function run_make_maintainer_clean_if_possible ()
1072 {
1073 if [ -f 'Makefile' ]; then
1074 make_maintainer_clean
1075 fi
1076 }
1077
1078 function run_autoreconf_if_required ()
1079 {
1080 if [ ! -x 'configure' ]; then
1081 run_autoreconf
1082 fi
1083
1084 assert_exec_file 'configure'
1085 bash -n configure
1086 }
1087
1088 function run_autoreconf ()
1089 {
1090 if [[ -z "$AUTORECONF" ]]; then
1091 die "Programmer error, tried to call run_autoreconf () but AUTORECONF was not set"
1092 fi
1093
1094 if test $use_libtool = 1; then
1095 assert $BOOTSTRAP_LIBTOOLIZE
1096 run $BOOTSTRAP_LIBTOOLIZE '--copy' '--install' '--force' || die "Cannot execute $BOOTSTRAP_LIBTOOLIZE"
1097 fi
1098
1099 run $AUTORECONF $AUTORECONF_ARGS || die "Cannot execute $AUTORECONF"
1100
1101 eval 'bash -n configure' || die "autoreconf generated a malformed configure"
1102 }
1103
1104 function run ()
1105 {
1106 if $VERBOSE; then
1107 echo "\`$@' $ARGS"
1108 fi
1109
1110 if [ -z "$1" ]; then
1111 return 127;
1112 fi
1113
1114 eval $@ $ARGS
1115 }
1116
1117 function parse_command_line_options ()
1118 {
1119 local SHORTOPTS=':apcmt:dvh'
1120
1121 nassert MAKE_TARGET
1122
1123 while getopts "$SHORTOPTS" opt; do
1124 case $opt in
1125 a) #--autoreconf
1126 AUTORECONF_OPTION=true
1127 MAKE_TARGET='autoreconf'
1128 ;;
1129 p) #--print-env
1130 PRINT_SETUP_OPTION=true
1131 ;;
1132 c) # --configure
1133 CONFIGURE_OPTION=true
1134 MAKE_TARGET='configure'
1135 ;;
1136 m) # maintainer-clean
1137 CLEAN_OPTION=true
1138 MAKE_TARGET='clean_op'
1139 ;;
1140 t) # target
1141 TARGET_OPTION=true
1142 TARGET_OPTION_ARG="$OPTARG"
1143 MAKE_TARGET="$OPTARG"
1144 ;;
1145 d) # debug
1146 DEBUG_OPTION=true
1147 enable_debug
1148 ;;
1149 h) # help
1150 echo "bootstrap.sh [options] optional_target ..."
1151 echo " -a # Just run autoreconf";
1152 echo " -p # Print ENV";
1153 echo " -c # Just run configure";
1154 echo " -m # Just run maintainer-clean";
1155 echo " -t # Make target";
1156 echo " -d # Enable debug";
1157 echo " -h # Show help";
1158 echo " -v # Be more verbose in output";
1159 exit
1160 ;;
1161 v) # verbose
1162 VERBOSE_OPTION=true
1163 VERBOSE=true
1164 ;;
1165 :)
1166 echo "Option -$OPTARG requires an argument." >&2
1167 exit 1
1168 ;;
1169 *)
1170 echo "$0: error - unrecognized option $1" 1>&2
1171 exit 1
1172 ;;
1173 esac
1174 done
1175
1176 shift $((OPTIND-1))
1177
1178 if [ -n "$1" ]; then
1179 MAKE_TARGET="$@"
1180 fi
1181 }
1182
1183 function determine_vcs ()
1184 {
1185 if [[ -d '.git' ]]; then
1186 VCS_CHECKOUT=git
1187 elif [[ -d '.bzr' ]]; then
1188 VCS_CHECKOUT=bzr
1189 elif [[ -d '.svn' ]]; then
1190 VCS_CHECKOUT=svn
1191 elif [[ -d '.hg' ]]; then
1192 VCS_CHECKOUT=hg
1193 else
1194 VCS_CHECKOUT=
1195 fi
1196
1197 if [[ -n "$VCS_CHECKOUT" ]]; then
1198 VERBOSE=true
1199 fi
1200 }
1201
1202 function require_libtoolise ()
1203 {
1204 use_libtool=0
1205 grep '^[ ]*A[CM]_PROG_LIBTOOL' configure.ac >/dev/null \
1206 && use_libtool=1
1207 grep '^[ ]*LT_INIT' configure.ac >/dev/null \
1208 && use_libtool=1
1209 }
1210
1211 function autoreconf_setup ()
1212 {
1213 # Set ENV MAKE in order to override "make"
1214 if [[ -z "$MAKE" ]]; then
1215 if command_exists 'gmake'; then
1216 MAKE=`type -p gmake`
1217 else
1218 if command_exists 'make'; then
1219 MAKE=`type -p make`
1220 fi
1221 fi
1222
1223 if [ "$VCS_CHECKOUT" ]; then
1224 if $DEBUG; then
1225 MAKE="$MAKE --warn-undefined-variables"
1226 fi
1227 fi
1228
1229 if $DEBUG; then
1230 MAKE="$MAKE -d"
1231 fi
1232 fi
1233
1234 if [[ -z "$GNU_BUILD_FLAGS" ]]; then
1235 GNU_BUILD_FLAGS="--install --force"
1236 fi
1237
1238 if $VERBOSE; then
1239 GNU_BUILD_FLAGS="$GNU_BUILD_FLAGS --verbose"
1240 fi
1241
1242 if [ -z "$ACLOCAL_PATH" ]; then
1243 ACLOCAL_PATH="/usr/local/share/aclocal $ACLOCAL_PATH"
1244 fi
1245
1246 if [[ -z "$WARNINGS" ]]; then
1247 if [[ -n "$VCS_CHECKOUT" ]]; then
1248 WARNINGS="all,error"
1249 else
1250 WARNINGS="all"
1251 fi
1252 fi
1253
1254 if test $use_libtool = 1; then
1255 if [[ -n "$LIBTOOLIZE" ]]; then
1256 BOOTSTRAP_LIBTOOLIZE=`type -p $LIBTOOLIZE`
1257
1258 if [[ -z "$BOOTSTRAP_LIBTOOLIZE" ]]; then
1259 echo "Couldn't find user supplied libtoolize, it is required"
1260 return 1
1261 fi
1262 else
1263 # If we are using OSX, we first check to see glibtoolize is available
1264 if [[ "$VENDOR_DISTRIBUTION" == "darwin" ]]; then
1265 BOOTSTRAP_LIBTOOLIZE=`type -p glibtoolize`
1266
1267 if [[ -z "$BOOTSTRAP_LIBTOOLIZE" ]]; then
1268 echo "Couldn't find glibtoolize, it is required on OSX"
1269 return 1
1270 fi
1271 else
1272 BOOTSTRAP_LIBTOOLIZE=`type -p libtoolize`
1273
1274 if [[ -z "$BOOTSTRAP_LIBTOOLIZE" ]]; then
1275 echo "Couldn't find libtoolize, it is required"
1276 return 1
1277 fi
1278 fi
1279 fi
1280
1281 if $VERBOSE; then
1282 LIBTOOLIZE_OPTIONS="--verbose $BOOTSTRAP_LIBTOOLIZE_OPTIONS"
1283 fi
1284
1285 if $DEBUG; then
1286 LIBTOOLIZE_OPTIONS="--debug $BOOTSTRAP_LIBTOOLIZE_OPTIONS"
1287 fi
1288
1289 # Here we set LIBTOOLIZE to true since we are going to invoke it via BOOTSTRAP_LIBTOOLIZE
1290 LIBTOOLIZE=true
1291 fi
1292
1293 # Test the ENV AUTOMAKE if it exists
1294 if [[ -n "$AUTOMAKE" ]]; then
1295 run $AUTOMAKE '--help' &> /dev/null || die "Failed to run AUTOMAKE:$AUTOMAKE"
1296 fi
1297
1298 # Test the ENV AUTOCONF if it exists
1299 if [[ -n "$AUTOCONF" ]]; then
1300 run $AUTOCONF '--help' &> /dev/null || die "Failed to run AUTOCONF:$AUTOCONF"
1301 fi
1302
1303 # Test the ENV AUTOHEADER if it exists
1304 if [[ -n "$AUTOHEADER" ]]; then
1305 run $AUTOHEADER '--help' &> /dev/null || die "Failed to run AUTOHEADER:$AUTOHEADER"
1306 fi
1307
1308 # Test the ENV AUTOM4TE if it exists
1309 if [[ -n "$AUTOM4TE" ]]; then
1310 run $AUTOM4TE '--help' &> /dev/null || die "Failed to run AUTOM4TE:$AUTOM4TE"
1311 fi
1312
1313 # Test the ENV AUTOHEADER if it exists, if not we add one and add --install
1314 if [[ -z "$ACLOCAL" ]]; then
1315 ACLOCAL="aclocal --install"
1316 fi
1317 run $ACLOCAL '--help' &> /dev/null || die "Failed to run ACLOCAL:$ACLOCAL"
1318
1319 if [[ -z "$AUTORECONF" ]]; then
1320 AUTORECONF=`type -p autoreconf`
1321
1322 if [[ -z "$AUTORECONF" ]]; then
1323 die "Couldn't find autoreconf"
1324 fi
1325
1326 if [[ -n "$GNU_BUILD_FLAGS" ]]; then
1327 AUTORECONF_ARGS="$GNU_BUILD_FLAGS"
1328 fi
1329 fi
1330
1331 run $AUTORECONF '--help' &> /dev/null || die "Failed to run AUTORECONF:$AUTORECONF"
1332 }
1333
1334 function print_setup ()
1335 {
1336 saved_debug_status=$DEBUG
1337 if $DEBUG; then
1338 disable_debug
1339 fi
1340
1341 echo '----------------------------------------------'
1342 echo 'BOOTSTRAP ENV'
1343 echo "AUTORECONF=$AUTORECONF"
1344 echo "HOST_OS=$HOST_OS"
1345 echo "VENDOR=$VENDOR"
1346 echo "VENDOR_DISTRIBUTION=$VENDOR_DISTRIBUTION"
1347 echo "VENDOR_RELEASE=$VENDOR_RELEASE"
1348
1349 echo "getopt()"
1350 if $AUTORECONF_OPTION; then
1351 echo "--autoreconf"
1352 fi
1353
1354 if $CLEAN_OPTION; then
1355 echo "--clean"
1356 fi
1357
1358 if $CONFIGURE_OPTION; then
1359 echo "--configure"
1360 fi
1361
1362 if $DEBUG_OPTION; then
1363 echo "--debug"
1364 fi
1365
1366 if $PRINT_SETUP_OPTION; then
1367 echo "--print-env"
1368 fi
1369
1370 if $TARGET_OPTION; then
1371 echo "--target=$TARGET_OPTION_ARG"
1372 fi
1373
1374 if $VERBOSE_OPTION; then
1375 echo "--verbose"
1376 fi
1377
1378 if [[ -n "$MAKE" ]]; then
1379 echo "MAKE=$MAKE"
1380 fi
1381
1382 if [[ -n "$MAKE_TARGET" ]]; then
1383 echo "MAKE_TARGET=$MAKE_TARGET"
1384 fi
1385
1386 if [[ -n "$PREFIX" ]]; then
1387 echo "PREFIX=$PREFIX"
1388 fi
1389
1390 if [[ -n "$TESTS_ENVIRONMENT" ]]; then
1391 echo "TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT"
1392 fi
1393
1394 if [[ -n "$VCS_CHECKOUT" ]]; then
1395 echo "VCS_CHECKOUT=$VCS_CHECKOUT"
1396 fi
1397
1398 if $VERBOSE; then
1399 echo "VERBOSE=true"
1400 fi
1401
1402 if $DEBUG; then
1403 echo "DEBUG=true"
1404 fi
1405
1406 if [[ -n "$WARNINGS" ]]; then
1407 echo "WARNINGS=$WARNINGS"
1408 fi
1409 echo '----------------------------------------------'
1410
1411 if $saved_debug_status; then
1412 enable_debug
1413 fi
1414 }
1415
1416 function make_clean_option ()
1417 {
1418 run_configure_if_required
1419
1420 make_maintainer_clean
1421
1422 if [[ "$VCS_CHECKOUT" == 'git' ]]; then
1423 run "$VCS_CHECKOUT" status --ignored
1424 elif [[ -n "$VCS_CHECKOUT" ]]; then
1425 run "$VCS_CHECKOUT" status
1426 fi
1427 }
1428
1429 function make_for_autoreconf ()
1430 {
1431 if [ -f 'Makefile' ]; then
1432 make_maintainer_clean
1433 fi
1434
1435 run_autoreconf
1436
1437 assert_no_file 'Makefile'
1438 }
1439
1440 function check_make_target()
1441 {
1442 case $1 in
1443 'self')
1444 ;;
1445 'rpm')
1446 ;;
1447 'gdb')
1448 ;;
1449 'clean_op')
1450 ;;
1451 'autoreconf')
1452 ;;
1453 'install-system')
1454 ;;
1455 'configure')
1456 ;;
1457 'distcheck')
1458 ;;
1459 'check')
1460 ;;
1461 'snapshot')
1462 ;;
1463 'mingw')
1464 ;;
1465 'universe')
1466 ;;
1467 'valgrind')
1468 ;;
1469 'jenkins')
1470 ;;
1471 'distclean')
1472 ;;
1473 'maintainer-clean')
1474 ;;
1475 'install')
1476 ;;
1477 'all')
1478 ;;
1479 'make_default')
1480 ;;
1481 'clang')
1482 ;;
1483 'clang-analyzer')
1484 ;;
1485 test-*)
1486 ;;
1487 valgrind-*)
1488 ;;
1489 gdb-*)
1490 ;;
1491 'dist')
1492 ;;
1493 *)
1494 echo "Matched default"
1495 return 1
1496 ;;
1497 esac
1498
1499 return 0
1500 }
1501
1502 function bootstrap ()
1503 {
1504 determine_target_platform
1505
1506 determine_vcs
1507
1508 # Set up whatever we need to do to use autoreconf later
1509 require_libtoolise
1510 if ! autoreconf_setup; then
1511 return 1
1512 fi
1513
1514 if [ -z "$MAKE_TARGET" ]; then
1515 MAKE_TARGET="make_default"
1516 fi
1517
1518 if $PRINT_SETUP_OPTION -o $DEBUG; then
1519 echo
1520 print_setup
1521 echo
1522
1523 # Exit if all we were looking for were the currently used options
1524 if $PRINT_SETUP_OPTION; then
1525 exit
1526 fi
1527 fi
1528
1529 # Use OLD_TESTS_ENVIRONMENT for tracking the state of the variable
1530 local OLD_TESTS_ENVIRONMENT=
1531
1532 # Set ENV PREFIX in order to set --prefix for ./configure
1533 if [[ -n "$PREFIX" ]]; then
1534 PREFIX_ARG="--prefix=$PREFIX"
1535 fi
1536
1537 # We should always have a target by this point
1538 assert MAKE_TARGET
1539
1540 local MAKE_TARGET_ARRAY=($MAKE_TARGET)
1541
1542 for target in "${MAKE_TARGET_ARRAY[@]}"
1543 do
1544 # If we are running inside of Jenkins, we want to only run some of the possible tests
1545 if $jenkins_build_environment; then
1546 check_make_target $target
1547 ret=$?
1548 if [ $ret -ne 0 ]; then
1549 die "Unknown MAKE_TARGET option: $target"
1550 fi
1551 fi
1552
1553 local snapshot_run=false
1554 local valgrind_run=false
1555
1556 case $target in
1557 'self')
1558 self_test
1559 ;;
1560 'gdb')
1561 make_gdb
1562 ;;
1563 'install-html')
1564 make_install_html
1565 ;;
1566 'clean_op')
1567 make_clean_option
1568 ;;
1569 'autoreconf')
1570 make_for_autoreconf
1571 ;;
1572 'install-system')
1573 make_install_system
1574 ;;
1575 'configure')
1576 run_configure
1577 ;;
1578 'make_default')
1579 make_default
1580 ;;
1581 'clang')
1582 if ! check_clang; then
1583 die "clang was not found"
1584 fi
1585
1586 if ! make_for_clang; then
1587 die "Failed to build clang: $?"
1588 fi
1589 ;;
1590 'clang-analyzer')
1591 if ! check_clang_analyzer; then
1592 die "clang-analyzer was not found"
1593 fi
1594 if ! check_clang; then
1595 die "clang was not found"
1596 fi
1597
1598 if ! make_for_clang_analyzer; then
1599 die "Failed to build clang-analyzer: $?"
1600 fi
1601 ;;
1602 'mingw')
1603 if ! check_mingw; then
1604 die "mingw was not found"
1605 fi
1606
1607 if ! make_for_mingw; then
1608 die "Failed to build mingw: $?"
1609 fi
1610 ;;
1611 'snapshot')
1612 make_for_snapshot
1613 snapshot_run=true
1614 ;;
1615 'rpm')
1616 make_rpm
1617 ;;
1618 'darwin_malloc')
1619 make_darwin_malloc
1620 ;;
1621 'valgrind')
1622 make_maintainer_clean
1623 make_valgrind
1624 ;;
1625 'universe')
1626 make_universe
1627 ;;
1628 'jenkins')
1629 make_for_continuus_integration
1630 ;;
1631 *)
1632 run_configure_if_required
1633 make_target "$target"
1634 ;;
1635 esac
1636
1637 if $jenkins_build_environment; then
1638 if ! $snapshot_run; then
1639 run_make_maintainer_clean_if_possible
1640 fi
1641 fi
1642
1643 done
1644 }
1645
1646 function main ()
1647 {
1648 # Variables we export
1649 declare -x VCS_CHECKOUT=
1650
1651 # Variables we control globally
1652 local MAKE_TARGET=
1653 local CONFIGURE=
1654
1655 # Options for getopt
1656 local AUTORECONF_OPTION=false
1657 local CLEAN_OPTION=false
1658 local CONFIGURE_OPTION=false
1659 local DEBUG_OPTION=false
1660 local PRINT_SETUP_OPTION=false
1661 local TARGET_OPTION=false
1662 local TARGET_OPTION_ARG=
1663 local VERBOSE_OPTION=false
1664
1665 local OLD_CONFIGURE=
1666 local OLD_CONFIGURE_ARG=
1667 local OLD_PREFIX=
1668 local OLD_MAKE=
1669 local OLD_TESTS_ENVIRONMENT=
1670
1671 # If we call autoreconf on the platform or not
1672 local AUTORECONF_REBUILD_HOST=false
1673 local AUTORECONF_REBUILD=false
1674
1675 local -r top_srcdir=`pwd`
1676
1677 # Default configure
1678 if [ -z "$CONFIGURE" ]; then
1679 CONFIGURE="$top_srcdir/configure"
1680 fi
1681
1682
1683 # Variables for determine_target_platform () and rebuild_host_os ()
1684 # UNAME_MACHINE_ARCH= uname -m
1685 # VENDOR= apple, redhat, centos, canonical
1686 # VENDOR_RELEASE=
1687 # RHEL{rhel,Tikanga,Santiago}
1688 # Ubuntu{ubuntu,Lucid,Maverick,Natty,Oneiric,Precise,Quantal}
1689 # Fedora{fedora,Verne,Beefy}
1690 # OSX{osx,lion,snow,mountain}
1691 # VENDOR_DISTRIBUTION= darwin,fedora,rhel,ubuntu
1692 # UNAME_KERNEL= Linux, Darwin,...
1693 # UNAME_KERNEL_RELEASE= Linux, Darwin,...
1694 local UNAME_MACHINE_ARCH=unknown
1695 local VENDOR=unknown
1696 local VENDOR_RELEASE=unknown
1697 local VENDOR_DISTRIBUTION=unknown
1698 local UNAME_KERNEL=unknown
1699 local UNAME_KERNEL_RELEASE=unknown
1700 local HOST_OS=
1701
1702 rebuild_host_os no_output
1703
1704 parse_command_line_options $@
1705
1706 # If we are running under Jenkins we predetermine what tests we will run against
1707 # This MAKE_TARGET can be overridden by parse_command_line_options based MAKE_TARGET changes.
1708 # We don't want Jenkins overriding other variables, so we NULL them.
1709 if [ -z "$MAKE_TARGET" ]; then
1710 if $jenkins_build_environment; then
1711 if [[ -n "$label" ]]; then
1712 check_make_target $label
1713 if [ $? -eq 0 ]; then
1714 MAKE_TARGET="$label"
1715 fi
1716 fi
1717
1718 if [ -z "$MAKE_TARGET" ]; then
1719 MAKE_TARGET='jenkins'
1720 fi
1721 fi
1722 fi
1723
1724 bootstrap
1725
1726 jobs -l
1727 wait
1728
1729 exit 0
1730 }
1731
1732 function set_branch ()
1733 {
1734 if [ -z "$BRANCH" ]; then
1735 if [ -z "$CI_PROJECT_TEAM" ]; then
1736 die "Variable CI_PROJECT_TEAM has not been set"
1737 fi
1738 if [ -z "$PROJECT" ]; then
1739 die "Variable PROJECT has not been set"
1740 fi
1741 if [ -z "$BUILD_TAG" ]; then
1742 die "Variable BUILD_TAG has not been set"
1743 fi
1744
1745 BRANCH="lp:~$CI_PROJECT_TEAM/$PROJECT/$BUILD_TAG"
1746 export BRANCH
1747 fi
1748
1749 if [ -z "$BRANCH" ]; then
1750 die "Missing values required to build BRANCH variable."
1751 fi
1752 }
1753
1754 function merge ()
1755 {
1756 if [ -z "$VCS_CHECKOUT" ]; then
1757 die "Merges require VCS_CHECKOUT."
1758 fi
1759
1760 set_branch
1761
1762 if [[ "$VCS_CHECKOUT" == 'bzr' ]]; then
1763 if test -n "$BRANCH_TO_MERGE"; then
1764 bzr merge $BRANCH_TO_MERGE
1765 bzr commit --message="Merge $BRANCH_TO_MERGE Build: $BUILD_TAG" --unchanged
1766 fi
1767
1768 bzr push "$BRANCH"
1769 elif [[ -n "$VCS_CHECKOUT" ]]; then
1770 die "Merge attempt occured, current VCS setup does not support this"
1771 fi
1772 }
1773
1774 function enable_debug ()
1775 {
1776 if ! $DEBUG; then
1777 local caller_loc=`caller`
1778 if [ -n $1 ]; then
1779 echo "$caller_loc Enabling debug: $1"
1780 else
1781 echo "$caller_loc Enabling debug"
1782 fi
1783 set -x
1784 DEBUG=true
1785 fi
1786 }
1787
1788 function usage ()
1789 {
1790 cat << EOF
1791 Usage: $program_name [OPTION]..
1792
1793 Bootstrap this package from the checked-out sources, and optionally walk through CI run.
1794
1795 Options:
1796
1797 EOF
1798 }
1799
1800 function disable_debug ()
1801 {
1802 set +x
1803 DEBUG=true
1804 }
1805
1806 # Script begins here
1807
1808 program_name=$0
1809
1810 env_debug_enabled=false
1811 if [[ -n "$JENKINS_HOME" ]]; then
1812 declare -r jenkins_build_environment=true
1813 else
1814 declare -r jenkins_build_environment=false
1815 fi
1816
1817 export ACLOCAL
1818 export AUTOCONF
1819 export AUTOHEADER
1820 export AUTOM4TE
1821 export AUTOMAKE
1822 export AUTORECONF
1823 export CONFIGURE_ARG
1824 export DEBUG
1825 export GNU_BUILD_FLAGS
1826 export LIBTOOLIZE
1827 export LIBTOOLIZE_OPTIONS
1828 export MAKE
1829 export PREFIX_ARG
1830 export TESTS_ENVIRONMENT
1831 export VERBOSE
1832 export WARNINGS
1833
1834 case $OSTYPE in
1835 darwin*)
1836 export MallocGuardEdges
1837 export MallocErrorAbort
1838 export MallocScribble
1839 ;;
1840 esac
1841
1842 # We check for DEBUG twice, once before we source the config file, and once afterward
1843 env_debug_enabled=false
1844 if [[ -n "$DEBUG" ]]; then
1845 env_debug_enabled=true
1846 enable_debug
1847 print_setup
1848 fi
1849
1850 # Variables which only can be set by .bootstrap
1851 BOOTSTRAP_SNAPSHOT=false
1852 BOOTSTRAP_SNAPSHOT_CHECK=
1853
1854 if [ -f '.bootstrap' ]; then
1855 source '.bootstrap'
1856 fi
1857
1858 if $env_debug_enabled; then
1859 enable_debug
1860 else
1861 if [[ -n "$DEBUG" ]]; then
1862 enable_debug "Enabling DEBUG from '.bootstrap'"
1863 print_setup
1864 fi
1865 fi
1866
1867 # We do this in order to protect the case where DEBUG
1868 if ! $env_debug_enabled; then
1869 DEBUG=false
1870 fi
1871
1872 main $@